__all__ = ['Timer']

from collections.abc import Callable
from typing import ClassVar

class Timer:
    id: ClassVar[int]
    finalT: float
    currT: float
    name: str
    started: bool
    callback: Callable[[], object] | None
    def __init__(self, name: str | None = None) -> None: ...
    def start(self, t: float, name: str) -> None: ...
    def startCallback(self, t: float, callback: Callable[[], object]) -> None: ...
    def stop(self) -> float: ...
    def resume(self) -> None: ...
    def restart(self) -> None: ...
    def isStarted(self) -> bool: ...
    def addT(self, t: float) -> None: ...
    def setT(self, t: float) -> None: ...
    def getT(self) -> float: ...
