__all__ = ['Floater', 'FloaterGroup', 'FloaterWidget']

import tkinter
from typing import Final, Literal

import Pmw  # type: ignore[import-untyped]

from .Valuator import Valuator

FLOATER_WIDTH: Final = 22
FLOATER_HEIGHT: Final = 18

class Floater(Valuator): ...

class FloaterWidget(Pmw.MegaWidget):
    value: float
    def __init__(self, parent=None, **kw) -> None: ...
    def set(self, value, fCommand: bool = ...) -> None: ...
    def updateIndicator(self, value) -> None: ...
    def get(self) -> float: ...
    def mouseDown(self, event) -> None: ...
    def updateFloaterTask(self, state) -> Literal[1]: ...
    def updateFloaterSF(self, event) -> Literal[0] | None: ...
    def mouseUp(self, event) -> None: ...
    def setNumDigits(self) -> None: ...
    def setRelief(self) -> None: ...
    def setBorderwidth(self) -> None: ...
    def setBackground(self) -> None: ...
    def highlightWidget(self, event) -> None: ...
    def restoreWidget(self, event) -> None: ...

class FloaterGroup(Pmw.MegaToplevel):
    balloon: Pmw.Balloon
    toggleBalloonVar: tkinter.IntVar
    floaterList: list[Floater]
    def __init__(self, parent=None, **kw): ...
    def toggleBalloon(self) -> None: ...
    def get(self) -> list: ...
    def getAt(self, index: int): ...
    def set(self, value, fCommand: bool = ...) -> None: ...
    def setAt(self, index: int, value) -> None: ...
    def reset(self) -> None: ...
